﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.Algorithms.PushGP.Interpreter;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Boolean
{
    public class BooleanPushExpression : Expression
    {
        private readonly bool value;
        public BooleanPushExpression(bool value)
        {
            this.value = value;
        }

        public override bool IsCodeOp { get { return false; } }

        public override void Eval(IInterpreter interpreter)
        {
            interpreter.BooleanStack.Push(this.value);
        }

        public override string ToString()
        {
            return this.value.ToString().ToUpper();
        }
    }
}
