﻿using HeuristicLab.Algorithms.PushGP.Interpreter;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Code
{
    public class CodeDoExpression : Expression
    {
        public override bool IsCodeOp { get { return true; } }

        public override void Eval(IInterpreter interpreter)
        {
            // not enough arguments on stack
            if (interpreter.CodeStack.Count == 0)
                return;

            var expression = interpreter.CodeStack.Pop();
            interpreter.ExecStack.Push(expression);
        }

        public override string ToString()
        {
            return Symbols.CodeDo;
        }
    }
}
