﻿using HeuristicLab.Algorithms.PushGP.Interpreter;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Code
{
    public class CodeQuoteExpression : Expression
    {
        public override bool IsCodeOp { get { return true; } }

        public override void Eval(IInterpreter interpreter)
        {
            // not enough arguments on stack
            if (interpreter.ExecStack.Count == 0)
                return;

            var expression = interpreter.ExecStack.Pop();
            interpreter.CodeStack.Push(expression);
        }

        public override string ToString()
        {
            return Symbols.CodeQuote;
        }
    }
}
