﻿using HeuristicLab.Algorithms.PushGP.Interpreter;

namespace HeuristicLab.Algorithms.PushGP.Expressions.Exec
{
    public class ExecPushExpression : Expression
    {
        private readonly Expression value;
        public ExecPushExpression(Expression value)
        {
            this.value = value;
        }

        public override bool IsCodeOp { get { return false; } }

        public override void Eval(IInterpreter interpreter)
        {
            interpreter.ExecStack.Push(this.value);
        }

        public override string ToString()
        {
            return this.value.ToString();
        }
    }
}
